<?php

if( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

require_once (ROSTER_LIB . 'skill.php');
require_once (ROSTER_LIB . 'recipes.php');

// This part courtesy of Ulminia
// Enable tooltips

$roster->output['html_head'] = '<script src="http://www.wowhead.com/widgets/power.js"></script>
<script type="text/javascript" src="http://common.allakhazam.com/shared/common.js"></script>';

function get_icon_link($string){
	$id = null;
    $matches = array('/db/spell.html?wspell=','/db/item.html?witem=','&source=live','&amp;source=live');
    $id = str_replace( $matches, '', $string );
	return $id;
}

function get_icon_linka($string){
	global $roster;
	$id = null;
	$matchesa = array('<a href="http://wow.allakhazam.com/db/item.html?witem=','"><img alt="" src="' . ROSTER_URL . $roster->config['interface_url'] . 'img/Interface/Icons"', '" alt="" height="32" width="32" border="0" /></a>','"><img alt="" src="');
	$imagex = str_replace( $matchesa, ':', $string );
//	aprint($imagex);
	if (stristr($imagex,":")) {
		list($a,$b,$c,$d) = explode(":", $imagex);
		return $b;
	} else {
		return null;
	}
}
// End tooltips part

// Assign initial tpl vars
$roster->tpl->assign_vars(array(
	'L_ITEM'	=> $roster->locale->act['item'],
	'L_NAME'	=> $roster->locale->act['name'],
	'L_SLVL'	=> $roster->locale->act['skill_level'],
	'L_DISPLAY'	=> (($addon['config']['display_mr_list'])?'inline-table':'none'),

	'R_THEME_PATH' => ROSTER_PATH . 'templates/' . $roster->tpl->tpl // Since Roster likes to set the THEME_PATH to the current template directory
	)
);

$charid = $roster->data['member_id'];
$skills = skill_get_many($charid);
$skill_list = array();
$i=0;
$skill_name = '';

$skill_name_divider = '';
foreach ($skills as $skillgroup)
{
	foreach ($skillgroup as $skill)
	{
		$st = $skill->data['skill_type'];
		if ($skill->data['skill_type']==$roster->locale->wordings[$roster->data['clientLocale']]['professions'] || $skill->data['skill_type']==$roster->locale->wordings[$roster->data['clientLocale']]['secondary'])
		{
			if ($skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['riding'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Fishing'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Skinning'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Mining'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Herbalism'])
			{
				$skill_list[$i] = $skill->data['skill_name'];
				$skill_level[$i] = $skill->data['skill_level'];
				$i++;
				$skill_name_header = $skill->data['skill_name'];

				$roster->tpl->assign_block_vars('mr', array(
					'LINK' => makelink('#' . strtolower(str_replace(' ','',$skill_name_header))),
					'NAME' => $skill_name_header,
					'DIVIDER' => $skill_name_divider,
					)
				);

				$skill_name_divider = '-&nbsp;';
			}
		}
	}
}

$allrecipes=array();
$i=0;
foreach($skill_list as $skill)
{
	switch($skill)
	{
		case $roster->locale->wordings[$roster->data['clientLocale']]['Alchemy']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Blacksmithing']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Cooking']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Enchanting']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Engineering']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['First Aid']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Leatherworking']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Tailoring']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Jewelcrafting']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=expert&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=artisan&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=master&locale='.$roster->data['clientLocale'],$addon['config']['mr_urlgrabber_timeout']);
			$i++;
			break;
		default:
			$allrecipes[$i] ='';
			$i++;
			break;
	}
}

foreach($allrecipes as $index => $allrecipesperskill)
{
	preg_match_all('/(?<=\<tr class=\"[dl]r\"\>)((.(?!\<\/tr))*)/si',$allrecipesperskill,$matches);
	foreach ($matches[0] as $nr => $recipe)
	{
		preg_match_all('/(\<td[\w \\\'\"=]*\>)(.*)(?=\<\/td)/mi',$recipe,$lines)."\n";
//		aprint($lines);
		$parsedrecipes[$index][$nr]['icon'] = strtolower($lines[2][0]);
//		preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)/i',$parsedrecipes[$index][$nr]['icon'],$match);
//		$fulliconlink = "<a href=\"http://wow.allakhazam.com".$match[2]."&locale=".$roster->data['clientLocale'];
		$parsedrecipes[$index][$nr]['icon'] = str_replace("src=\"/images/icons", "src=\"".$roster->config['interface_url']."Interface/Icons", $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace(".png", ".".$roster->config['img_suffix']."\" alt=\"" , $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace("href=\"", "href=\"http://wow.allakhazam.com" , $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace("\"><img", "&locale=".$roster->data['clientLocale']."\"><img" , $parsedrecipes[$index][$nr]['icon']);
		preg_match_all('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)/i',$lines[2][1],$name);
//		aprint($name);
		$parsedrecipes[$index][$nr]['name'] = $name[3][0];
		//preg_match('/href=\"([^\"]*)\"/i',$lines[2][5],$link);
		//$recipes[$index][$nr]['components'] = $lines[2][4];
		if(array_key_exists('0',$name[2]))
		{
			$parsedrecipes[$index][$nr]['i_link'] = $name[2][0];
		}
		//$recipes[$index][$nr]['category'] = $lines[2][2];
		$parsedrecipes[$index][$nr]['skill'] = $lines[2][3];
//		preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)(.*(\<a[^\>]* href=\"([^\"]*)\"\>\<span[^\>]*\>)([^<]*))?/i',$lines[2][1],$name);
		$parsedrecipes[$index][$nr]['r_link'] = $name[2][0];
		if (isset($name[3][1]))
		{
			$parsedrecipes[$index][$nr]['pat_link'] = $name[2][1];
			$parsedrecipes[$index][$nr]['pat_name'] = $name[3][1];
		}
	}
}

//aprint($parsedrecipes);

$known = recipe_get_many( $charid,'', 'level' );
// aprint($known);
foreach($known as $kindex => $krecipe)
{
	$knownrecipenames[]=$krecipe->data['recipe_name'];
}

foreach($skill_list as $sindex => $skill)
{
	foreach($parsedrecipes[$sindex] as $nr => $recipe)
	{
		$allrecipenames[$sindex][]=str_replace("&nbsp;"," ",$recipe['name']);
	}
//	$diffrecipenames[$sindex] = array_diff($allrecipenames[$sindex],$knownrecipenames);
	foreach($allrecipenames[$sindex] as $recipekey => $recipename) {
		if (!in_array($recipename,$knownrecipenames)) {
			$diffrecipenames[$sindex][$recipekey]=$recipename;
		}
	}
//	aprint($allrecipenames[$sindex]);
//	aprint($knownrecipenames);
//	aprint($diffrecipenames[$sindex]);
}

//aprint($allrecipenames);
//aprint($knownrecipenames);

//aprint($skill_level);
//aprint($diffrecipenames);

foreach($skill_list as $sindex => $skill_name)
{
	list($charskill_level, $maxskill_level) = explode(':', $skill_level[$sindex], 2);
	// make skill header
	// Set an link to the top behind the profession image
	$skill_image = 'Interface/Icons/' . $roster->locale->wordings[$roster->data['clientLocale']]['ts_iconArray'][$skill_name];

	$roster->tpl->assign_block_vars('mr_skill', array(
		'INDEX' => $sindex,
		'ICON' => $skill_image,
		'ANCHOR' => strtolower(str_replace(' ','',$skill_name)),
		'NAME'   => $skill_name,
		'LEVEL' => $charskill_level,
		'MAXLEVEL' => $maxskill_level,
		)
	);

	foreach($diffrecipenames[$sindex] as $dindex => $diffrecipename)
	{
		// make recipe row
		// skill level color (thanks to Ulminia)

		// Improved skill color by Zanix

		// Strip out &nbsp; for a clean match
		$skill_check = str_replace('&nbsp;','',$parsedrecipes[$sindex][$dindex]['skill']);
		preg_match_all('/<span class="(.+?)">(.+?)<\/span>/i',$skill_check,$skillmatches);

		// Check for difficulty level, set to red if it doesn't meet orange level
		// Also keep the previous color if it doesn't exceed the next level
		$skill_color = ( $charskill_level >= $skillmatches[2][0] ? 'orange' : 'red');
		$skill_color = ( $charskill_level >= $skillmatches[2][1] ? 'yellow' : $skill_color);
		$skill_color = ( $charskill_level >= $skillmatches[2][2] ? 'green' : $skill_color);
		$skill_color = ( $charskill_level >= $skillmatches[2][3] ? 'grey' : $skill_color);

		// Implode the color level arry into a string we can use
		$skill_levels = implode(' ',$skillmatches[2]);

		// Check if the recipe exists in the database and use the tooltip data
		$sqlquery = 'SELECT recipe_name, item_color, recipe_tooltip FROM '.$roster->db->table('recipes').' WHERE recipe_name = "'.$parsedrecipes[$sindex][$dindex]['name'].'"';
		$sqlresult = $roster->db->query($sqlquery);
		$sqlrow = $roster->db->fetch($sqlresult);
		$inserttt = '';
		if ($sqlrow)
		{
			$inserttt = makeOverlib($sqlrow['recipe_tooltip']."\n",$sqlrow['recipe_name'],'',0,'','');
		}

		$link = '';
		if(array_key_exists('i_link', $parsedrecipes[$sindex][$dindex]))
		{
			//$link = 'http://wow.allakhazam.com'.$parsedrecipes[$sindex][$dindex]['i_link'];
			$link = "http://www.wowhead.com/?item=".get_icon_linka($parsedrecipes[$sindex][$dindex]['icon']);
		}

		$plink = $pname = '';
		if(array_key_exists('pat_link', $parsedrecipes[$sindex][$dindex]))
		{
			//$plink = "http://wow.allakhazam.com".$parsedrecipes[$sindex][$dindex]['pat_link'];
			$plink = "http://www.wowhead.com/?item=".get_icon_link($parsedrecipes[$sindex][$dindex]['pat_link']);
			$pname = $parsedrecipes[$sindex][$dindex]['pat_name'];
		}

		$roster->tpl->assign_block_vars('mr_skill.mr_recipe', array(
			'ROW_CLASS' => $roster->switch_row_class(),
			'TOOLTIP' => $inserttt,
			'ICON' => $parsedrecipes[$sindex][$dindex]['icon'],
			'NAME' => $parsedrecipes[$sindex][$dindex]['name'],
			'SKILL' => $skill_levels,
			'LINK' => $link,
			'PNAME' => $pname,
			'PLINK' => $plink,
			'SKILLCOLOR' => $skill_color,
			)
		);
	}
}

$roster->tpl->set_handle('mr',$addon['basename'] . '/mr.html');
$roster->tpl->display('mr');
